//----------------------------------------------------------------------
// seqmemread 
// version 1.0
// F. Abignoli
// 4/5/2013
//----------------------------------------------------------------------
// Test de lecture de la memoire de preset du synthetiseur a table onde
// Programme prevu pour 24LC256
//----------------------------------------------------------------------


#include <Wire.h> //I2C library
#include <LiquidCrystal_I2C.h>
#if defined(ARDUINO) && ARDUINO >= 100
#define printByte(args)  write(args);
#else
#define printByte(args)  print(args,BYTE);
#endif

LiquidCrystal_I2C lcd(0x27,16,2);       // sLCD adress 0x27, 16 car, 2 lignes



#define MAXPROG 128
#define PRESETSIZE  64


char nompreset[17];   


void eewrite_byte( int deviceaddress, unsigned int eeaddress, byte data ) 
{
int rdata = data;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.write(rdata);
  Wire.endTransmission();
  delay(5);
}

byte eeread_byte( int deviceaddress, unsigned int eeaddress ) {
  byte rdata = 0xFF;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.endTransmission();
  Wire.requestFrom(deviceaddress,1);
  if (Wire.available()) rdata = Wire.read();
    return rdata;
}

void setup() 
{
  //Wire.begin(); // initialise the connection
  lcd.init();             // init du lcd 
  lcd.backlight();        // Retroeclairage
  lcd.clear();            // Effacement de lecran
  lcd.setCursor(0,0);
}

void lire_nompreset(byte mypreset)
{
int i;
int myaddress=0;
char bufnum[4];
int n;
    memset(nompreset,0,sizeof(nompreset));
    
    // Initialisation de l'adresse du preset
    myaddress=(mypreset*PRESETSIZE);
    for (i=0;i<16;i++) {
      nompreset[i]=eeread_byte( 0x50, myaddress++);
    }
    
}

void loop() 
{
int addr=0; // adress de debut
int i,j,k;  // variables de travail
        lcd.clear();
    for (i=0;i<MAXPROG;i++) {
        lire_nompreset(i);
        lcd.setCursor(0,0);
        lcd.print(i,DEC);
        lcd.setCursor(0,1);
        lcd.print(nompreset);
        delay(10);
    }
    lcd.setCursor(0,3);
    lcd.print("Fin de lecture");
    while(1) {
    }
    
}